/*
 * Proiect PM - Space Impact
 * Ciocioi Stefan-Viorel
 * Grupa 335CA
 */
 
#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <math.h>
#include "lcd.h"

#include "mpu6050/mpu6050.h"

#define DELAY_MOVE		75
#define CURSOR_MAX		173


#define MAX_LOW			5
#define MAX_HIGH		2
#define RIGHT			16
#define LEFT			1

#define VISIBLE			1
#define INVISIBLE		0


unsigned char level[][4] = {
	/* Wave 1 */
	{17, 3, VISIBLE, ENEMY},{19, 5, VISIBLE, ENEMY},
	{23, 4, VISIBLE, ENEMY},{28, 3, VISIBLE, ENEMY},
	/* Laser 1 */
	{32, 4, VISIBLE, LASER},
	/* Wave 2 */
	{37, 5, VISIBLE, ENEMY},{38, 4, VISIBLE, ENEMY},{39, 3, VISIBLE, ENEMY},
	{40, 2, VISIBLE, ENEMY},{41, 3, VISIBLE, ENEMY},{42, 4, VISIBLE, ENEMY},
	{43, 5, VISIBLE, ENEMY},{44, 4, VISIBLE, ENEMY},{45, 3, VISIBLE, ENEMY},
	{46, 2, VISIBLE, ENEMY},
	/* Life 1 */
	{50, 4, VISIBLE, LIFE},
	/* Wave 3 */
	{53, 3, VISIBLE, ENEMY},{53, 5, VISIBLE, ENEMY},
	{56, 2, VISIBLE, ENEMY},{56, 4, VISIBLE, ENEMY},
	{59, 3, VISIBLE, ENEMY},{59, 5, VISIBLE, ENEMY},
	{62, 2, VISIBLE, ENEMY},{62, 4, VISIBLE, ENEMY},
	/* Wave 4 */
	{66, 4, VISIBLE, ENEMY},
	{70, 5, VISIBLE, ENEMY},{71, 2, VISIBLE, ENEMY},{73, 3, VISIBLE, ENEMY},
	{75, 5, VISIBLE, ENEMY},{78, 2, VISIBLE, ENEMY},
	/* Life 2 */
	{81, 4, VISIBLE, LIFE},
	/* Wave 5 */
	{85, 2, VISIBLE, ENEMY},{85, 3, VISIBLE, ENEMY},{85, 4, VISIBLE, ENEMY},
	{85, 5, VISIBLE, ENEMY},
	/* Laser 2 */
	{88, 4, VISIBLE, LASER},
	/* Wave 6 */
	{91, 2, VISIBLE, ENEMY},{91, 3, VISIBLE, ENEMY},{91, 4, VISIBLE, ENEMY},
	{91, 5, VISIBLE, ENEMY},
	/* Life 3 */
	{95, 4, VISIBLE, LIFE},
	/* Wave 7 */
	{98, 5, VISIBLE, ENEMY},{99, 4, VISIBLE, ENEMY},{100, 3, VISIBLE, ENEMY},
	{101, 2, VISIBLE, ENEMY},{102, 3, VISIBLE, ENEMY},{103, 4, VISIBLE, ENEMY},
	{104, 5, VISIBLE, ENEMY},{105, 4, VISIBLE, ENEMY},{106, 3, VISIBLE, ENEMY},
	{107, 2, VISIBLE, ENEMY},
	/* Wave 8 */
	{111, 3, VISIBLE, ENEMY},{111, 5, VISIBLE, ENEMY},
	{114, 2, VISIBLE, ENEMY},{114, 4, VISIBLE, ENEMY},
	/* Laser 3 */
	{117, 4, VISIBLE, LASER},
	/* Wave 9 */
	{120, 5, VISIBLE, ENEMY},{121, 4, VISIBLE, ENEMY},{122, 3, VISIBLE, ENEMY},
	{123, 2, VISIBLE, ENEMY},{124, 3, VISIBLE, ENEMY},{125, 4, VISIBLE, ENEMY},
	{126, 5, VISIBLE, ENEMY},{127, 4, VISIBLE, ENEMY},{128, 3, VISIBLE, ENEMY},
	{129, 2, VISIBLE, ENEMY},
	/* Laser 4 */
	{132, 4, VISIBLE, LASER},
	/* Wave 10 */
	{135, 5, VISIBLE, ENEMY},{136, 2, VISIBLE, ENEMY},
	{138, 4, VISIBLE, ENEMY},{140, 2, VISIBLE, ENEMY},
	/* Life 4 5 */
	{146, 4, VISIBLE, LIFE},
	/* Laser 5 */
	{150, 4, VISIBLE, LASER},
	/* Boss */
	{165, 4, VISIBLE, BOSS2},{165, 3, VISIBLE, BOSS1},{166, 2, VISIBLE, BOSS1},
	{166, 3, VISIBLE, BOSS3},{166, 4, VISIBLE, BOSS3},{166, 5, VISIBLE, BOSS2}
	};
	
unsigned char projectiles[][4] = {
	{2, 2, INVISIBLE, FIRE}, // Proiectil linia 2
	{2, 3, INVISIBLE, FIRE}, // Proiectil linia 3
	{2, 4, INVISIBLE, FIRE}, // Proiectil linia 4
	{2, 5, INVISIBLE, FIRE}  // Proiectil linia 5
};

unsigned char old[][2] = {
	{2, 2},
	{2, 3},
	{2, 4},
	{2, 5}
};



struct player {
	unsigned char player_x, player_y, type;
	unsigned char nLives, nPower;
	unsigned char score;
};

unsigned char cursor, player_height, end_game, acc;
int length;

char scorechr[17];
struct player Player;

/* Initializari variabile */
void game_init()
{
	Player.player_x = 1;
	Player.player_y = 3;
	Player.type = SHIP;
	Player.nLives = 3;
	Player.nPower = 6;
	Player.score = 0;
	
	cursor = 1;
	player_height = 5;
	length = sizeof(level) / 4;
	
	end_game = 0;
	
}

/* initializeaza intrarile si iesirile */
void IO_init() {
    // butoanele setate ca intrare
    DDRD &= ~((1 << PD1) | (1 << PD0) | (1 << PD5) | (1 << PD4));
	
	// activare rezistente de pull-up
    PORTD |= ((1 << PD1) | (1 << PD0) | (1 << PD5) | (1 << PD4));
	
	// activare buzzer pin de iesire
	DDRC |= (1 << PC3);
	
	/* oprire buzzer */
	PORTC &= ~(1 << PC3);
}

void move_player() {
	
	/* Merge in sus */
	if((PIND & (1 << PD0)) == 0) {
		if (Player.player_y > MAX_HIGH) {
			Player.player_y--;
		}
	/* Merge in jos */
	} else if((PIND & (1 << PD1)) == 0) {
		if (Player.player_y < MAX_LOW) {
			Player.player_y++;
		}
	}
}

void activate() {
	
	if((PIND & (1 << PD0)) == 0) {
		if (acc == 0)
			acc = 1;
	}
	
}

double backup;

void accel_move() {
	
	double axg, ayg, azg, gxds, gyds, gzds;
	
	axg = ayg = azg = 0;
	gxds = gyds = gzds = 0;
	
	mpu6050_getConvData(&axg, &ayg, &azg, &gxds, &gyds, &gzds);
	
	if (azg > 0.380)
		Player.player_y = 2;
	else if (azg <= 0.380 && azg > 0.360)
		Player.player_y = 3;
	else if (azg <= 0.360 && azg > 0.340)
		Player.player_y = 4;
	else
		Player.player_y = 5;
	
	backup = azg;
	
}

void check_collision() {
	unsigned char i;
	
	for (i = 0; i < length; ++i) {
		if(level[i][0] == Player.player_x 
		&& level[i][1] == Player.player_y 
		&& level[i][2] == VISIBLE) {
			switch (level[i][3]) {
			case ENEMY:
				Player.nLives--;
				break;
			case LIFE:
				if (Player.nLives < 3)
					Player.nLives++;
				break;
			case LASER:
				if (Player.nPower < 9)
					Player.nPower++;
				break;
			}
			level[i][2] = INVISIBLE;
		}
	}
}

void shoot () {
	
	unsigned char c = Player.player_y - 2;
	unsigned char i;
	
	/* Shoot clasic - cate un proiectil pe linie */
	if((PIND & (1 << PD5)) == 0) {
		if (projectiles[c][2] == INVISIBLE) {
			projectiles[c][2] = VISIBLE;
			PINC = (1 << PC3);
		}

	/* Putere speciala - Wipe */
	
	} else if((PIND & (1 << PD4)) == 0) {
		if (Player.nPower > 6) {
			for (i = 0; i < length; ++i) {
				if (level[i][0] <= RIGHT && level[i][3] == ENEMY) {
					level[i][2] = INVISIBLE;
					Player.score++;
				}
			}
			Player.nPower--;
		}
	}
	
}

void fire_collision() {
	unsigned char i, j;
	
	/* Detectare coliziune proiectil - inamic */
	for (j = 0; j < 4; ++j) {
		if (projectiles[j][2] == VISIBLE) {
			for (i = 0; i < length; ++i) {
				if (level[i][2] == VISIBLE && 
				(level[i][3] == ENEMY ||
				level[i][3] == BOSS1 ||
				level[i][3] == BOSS2 ||
				level[i][3] == BOSS3)
				) {
					if (projectiles[j][1] == level[i][1] &&		// Au acelasi y
						(projectiles[j][0] == level[i][0] ||	// Au acelasi x
						projectiles[j][0] == (level[i][0] + 1) ||
						projectiles[j][0] == (level[i][0] - 1))) {		
							level[i][2] = INVISIBLE;
							projectiles[j][2] = INVISIBLE;
							projectiles[j][0] = old[j][0];
							projectiles[j][1] = old[j][1];
							Player.score++;
						}
				}
			}
		}
	}
}

void draw_layout() {
	
	unsigned char x, y;
	unsigned char i;
	
	/* Scor */
	lcd_goto_xy(15, 1);
	lcd_str(scorechr);
	
	/* Vieti */
	for (x = 1, y = 1; x <= Player.nLives; ++x) {
		lcd_goto_xy(x, y);
		lcd_chr(LIFE);
	}
	
	/* Pamant */
	for (x = 1, y = 6; x < 17; x++) {
		lcd_goto_xy(x, y);
		lcd_chr(GROUND);
	}
	
	/* Laser */
	for (x = 7, y = 1; x <= Player.nPower; ++x) {
		lcd_goto_xy(x, y);
		lcd_chr(LASER);
	}
	
	/* Nivel complet */
	for (i = 0; i < length; ++i) {
		if(level[i][0] <= RIGHT && level[i][2] == VISIBLE) {
			lcd_goto_xy(level[i][0], level[i][1]);
			lcd_chr(level[i][3]);
		}
	}
	
	/* Afisare proiectile inca vizibile */
	for (i = 0; i < 4; ++i) {
		if (projectiles[i][0] <= RIGHT && projectiles[i][2] == VISIBLE) {
			lcd_goto_xy(projectiles[i][0], projectiles[i][1]);
			lcd_chr(projectiles[i][3]);
		}
	}
}

int main(void) {
	
	/* Initializare I/O */
	unsigned char i;
	unsigned char verify = 0;
	
	//sei();
	IO_init();

	/* Setup LCD */
	lcd_init();
	mpu6050_init();
	lcd_contrast(0x40);
	
	game_init();
	
	char *m = "SPACE IMPACT";
	char *ts = "TO START:";
	char *s = "'UP' - ACCMETER"; 
	char *t = "'DOWN' - NORMAL";
	char *sc = "FINAL SCORE:";
	
	while (1) {
		lcd_goto_xy(1,2);
		lcd_str(m);
		lcd_goto_xy(1,3);
		lcd_str(ts);
		lcd_goto_xy(1,4);
		lcd_str(s);
		lcd_goto_xy(1,5);
		lcd_str(t);
		
		activate();
		if (acc)
			break;
		
		if ((PIND & (1 << PD1)) == 0) {
			break;
		}
		_delay_ms(50);
	}
	
	while (1) {
		
		/* oprire buzzer */
		PORTC &= ~(1 << PC3);
		
		verify = 0;
		
		check_collision();
		if (Player.nLives == 0)
			break;
		
		if (acc)
			accel_move();
		else
			move_player();
		
		shoot();
		
		lcd_clear();
		
		sprintf(scorechr, "%d", Player.score);
		
		lcd_goto_xy(Player.player_x, Player.player_y);
		lcd_chr(Player.type);
		
		draw_layout();
		cursor++;

		/* Iesire din ecran */
		for (i = 0; i < 4; ++i) {
			if (projectiles[i][2] == VISIBLE) {
				projectiles[i][0]++;
				if (projectiles[i][0] > RIGHT) {
					projectiles[i][2] = INVISIBLE;
					projectiles[i][0] = old[i][0];
					projectiles[i][1] = old[i][1];
				}
				
			}
		}
		
		fire_collision();
		
		if (cursor < 152) {
			for (i = 0; i < length; ++i) {
				level[i][0]--;
				if (level[i][0] < 1)
					level[i][2] = INVISIBLE;
			}
		}
		
		for (i = length - 7; i < length; ++i) {
			if (level[i][2] == VISIBLE)
				verify = 1;
		}
		
		if (verify == 0)
			break;
		
		_delay_ms(200);
	}
	
	m = "SPACE IMPACT";
	s = "GAME OVER!";
	
	lcd_clear();

	while (1) {
		lcd_goto_xy(1,2);
		lcd_str(m);
	
		lcd_goto_xy(1,3);
		lcd_str(s);
		
		lcd_goto_xy(1,4);
		lcd_str(sc);
		
		lcd_goto_xy(1,5);
		lcd_str(scorechr);
		
		if ((PIND & (1 << PD5)) == 0) {
			break;
		}
		_delay_ms(50);
	}	

	return 0;
}
